%define name crossfire
%define version 0.95.2
%define release 5

Name: %{name}
Version: %{version}
Release: %{release}
Summary:  Role-playing graphical adventure game.
Group: X11/Games
Copyright: GPL
Distribution: Home grown weeds.
Vendor: Mark Wedel & Frank Tore Johansen
URL: http://crossfire.real-time.com
#Packager: Kjetil Wiekhorst Jrgensen, <jorgens+rpm@pvv.org>
#Source: ftp://ftp.ifi.uio.no/pub/crossfire/%{name}-%{version}.tar.bz2
# This is the canonical source:
Source0: ftp://ftp.pyramid.com/pub/crossfire/%{name}-%{version}.tar.bz2
Source1: ftp://ftp.pyramid.com/pub/crossfire/%{name}-%{version}-maps.tar.bz2
Source2: crossfire.init
Patch: crossfire-0.95.2-config.patch
Patch1: crossfire-0.95.0-perl.patch
Patch2: crossfire-0.95.1-character.patch
# The following probably is only needed for this version:
Patch3: crossfire-0.95.2-gate.patch
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-root
Prefixes: /usr/share/games/crossfire /usr/man

%description
	Crossfire is a highly graphical role-playing adventure game
with characteristics reminiscent of rogue, nethack, omega, and gauntlet.
It has multiplayer capability and presently runs under X11.

%prep
%setup
%patch0 -p1
%patch1 -p1
%patch2 -p1
# This (patch3) should only be needed for this version as it fixes a rather
# major flaw.
patch -p0 -l <$RPM_SOURCE_DIR/%{name}-0.95.2-gate.patch

cd lib
bzip2 -dc $RPM_SOURCE_DIR/%{name}-%{version}-maps.tar.bz2 | tar -xvf -

%build
CFLAGS="$RPM_OPT_FLAGS" \
./configure --prefix='${DESTDIR}'/usr --exec-prefix='${prefix}/games' \
  --sharedstatedir='${DESTDIR}'/var/lib/games/crossfire \
  --localstatedir='${DESTDIR}'/var/lib/games/crossfire \
  --bindir='${prefix}'/games --libdir='${prefix}'/share/games/crossfire \
  --mandir='${prefix}'/man 
make depend
make

%install
test -d $RPM_BUILD_ROOT && rm -rf $RPM_BUILD_ROOT
make install DESTDIR="$RPM_BUILD_ROOT"
mkdirhier  $RPM_BUILD_ROOT/etc/rc.d/init.d
install -c -m 755 $RPM_SOURCE_DIR/crossfire.init $RPM_BUILD_ROOT/etc/rc.d/init.d/crossfire
find $RPM_BUILD_ROOT -name \*.orig -print0 | xargs -0 rm -f 
find doc -name \*.orig -print0 | xargs -0 rm -f 
cp -pr doc  $RPM_BUILD_ROOT/usr/share/games/crossfire/doc

cd $RPM_BUILD_ROOT/usr/games
for a in crossloop; do
        sed "s=$RPM_BUILD_ROOT==" < $a > $a.$$ && mv $a.$$ $a
done
strip crossfire

# Here's a script that was missed in the perl patch....
cd $RPM_BUILD_ROOT/usr/share/games/crossfire/maps/world
for a in connect.pl; do
	sed 's=/usr/local/bin/perl=/usr/bin/perl=' <$a >$a.$$ && mv $a.$$ $a
done

# I haven't figured out a way to separate the variable data from the
# static data using the build proceedure's yet, so this is a hack around:
cd $RPM_BUILD_ROOT/usr/share/games/crossfire
mkdirhier $RPM_BUILD_ROOT/var/lib/games/crossfire
for a in highscore players unique-items; do
	cp -pr $RPM_BUILD_ROOT/usr/share/games/crossfire/$a \
               $RPM_BUILD_ROOT/var/lib/games/crossfire/$a
	rm -rf $RPM_BUILD_ROOT/usr/share/games/crossfire/$a
	ln -sf /var/lib/games/crossfire/$a .
done
for a in temp.maps bookarch; do
	touch ${RPM_BUILD_ROOT}/var/lib/games/crossfire/$a
	ln -sf /var/lib/games/crossfire/$a .
done
# I've started saving the temp-maps in this directory to protect them between
# invocations of crossfire.
for a in temp-maps; do
	mkdir ${RPM_BUILD_ROOT}/var/lib/games/crossfire/$a
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add crossfire

%preun
if [ "$1" = 0 ] ; then
  if [ -f /var/lock/subsys/crossfire ]; then
    /etc/rc.d/init.d/crossfire stop
  fi
  /sbin/chkconfig --del crossfire
fi

%files
%defattr(644,root,root,755)
%doc CHANGES CREDITS DEVELOPERS README License DONE TODO INSTALL
%attr(755,root,root) /usr/games/add_throw
%attr(755,root,root) /usr/games/crossedit
%attr(755,root,root) /usr/games/crossloop
%attr(755,root,root) /usr/games/flushlocks
%attr(755,root,root) /usr/games/mktable
%attr(755,root,root) /usr/games/random_map
%attr(6755,games,games) /usr/games/crossfire

%doc /usr/man/man1/crossfire.1
%doc /usr/man/man1/xbmtobdf.1
%doc /usr/man/man1/crossedit.1
%doc /usr/share/games/crossfire/doc

%attr (755,games,games) %dir /var/lib/games/crossfire
%attr (775,games,games) /var/lib/games/crossfire/players
%attr (775,games,games) /var/lib/games/crossfire/unique-items
%attr (755,games,games) /var/lib/games/crossfire/temp-maps
%config %attr (664,games,games) /var/lib/games/crossfire/highscore
%config %attr (664,games,games) /var/lib/games/crossfire/temp.maps
%config %attr (664,games,games) /var/lib/games/crossfire/bookarch

%dir /usr/share/games/crossfire
%dir /usr/share/games/crossfire/help
%dir /usr/share/games/crossfire/maps
/usr/share/games/crossfire/maps/*
/usr/share/games/crossfire/help/*
%config /usr/share/games/crossfire/ban_file
%config /usr/share/games/crossfire/dm_file
%config /usr/share/games/crossfire/forbid
%config /usr/share/games/crossfire/motd
/usr/share/games/crossfire/animations
/usr/share/games/crossfire/archetypes
/usr/share/games/crossfire/artifacts
/usr/share/games/crossfire/bmaps
/usr/share/games/crossfire/bmaps.paths
/usr/share/games/crossfire/crossfire.cfb
/usr/share/games/crossfire/crossfire.xpm
/usr/share/games/crossfire/def_help
/usr/share/games/crossfire/faces
/usr/share/games/crossfire/formulae
/usr/share/games/crossfire/messages
/usr/share/games/crossfire/races
/usr/share/games/crossfire/skill_params
/usr/share/games/crossfire/spell_params
/usr/share/games/crossfire/treasures
/usr/share/games/crossfire/players
/usr/share/games/crossfire/unique-items
/usr/share/games/crossfire/highscore
/usr/share/games/crossfire/bookarch

%attr(-,root,root) /etc/rc.d/init.d/crossfire

%changelog

* Tue Mar 16 1999 Toshio Kuratomi <badger@prtr-13.ucsc.edu> [0.95.2-5]
- Edited the patch files to get rid of redundancies and excesses.
- Moved files around to conform to the File Hierarchy Standard 2.0
- Changed portions of the spec to use configure to set up the directory
  structure rather than having to construct it manually.
- No longer package crossloop.pl as it is outdated by the newer crossloop
  shell script.
- Moved the tmp directory to be in /var/lib/games/crossfire/temp-maps...
  This way the temp maps are all in the var directory for reuse.
  I don't think crossfire keeps any other temp files around.
- Remove crossserv as it isn't necessary to the operation of crossfire as a
  server. (Instead set crossfire setuid/gruid games.
- Edit the crossfire.init script to reflect the absence of crossserv.
- Add maps to the package.  Will not run without this (but maybe it should be
  in a subpackage.)

* Sun Jan 31 1999 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.95.2-1]

- upgraded to version 0.95.2

* Fri Sep  4 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.95.1-1]

- upgraded to version 0.95.1
- fixed some minor bugs in the distribution
- dead is no longer final due to a bug in that code

* Fri Sep  4 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.94.3-1]

- upgraded to version 0.94.3
- moved some files around (static files to /usr/lib/games/crossfire and 
  dynamic files to /var/lib/games/crossfire)

* Mon Jun 01 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org>

- upgraded to 0.94.2.
- removed the client stuff, since crossfire has become client/server based.

* Sat Apr 25 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org>

- upgraded to 0.94.1.

* Sat Feb 08 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@zarhan.pvv.org>

- added the missing space between the number and the item name.
- fixed a bug which will allow the code to compile even if the ERIC_SERVER
  isn't defined.


* Sat Feb 08 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@zarhan.pvv.org>

- version 0.94.0
- minor bugfix in server code.

* Sat Feb 08 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@zarhan.pvv.org>

- new specfile for crossfire.
